(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      6619,        195]
NotebookOptionsPosition[      6002,        171]
NotebookOutlinePosition[      6348,        186]
CellTagsIndexPosition[      6305,        183]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
Example of using Mint with LiteRed\
\>", "Title",
 CellChangeTimes->{{3.5867451931453557`*^9, 3.5867451985329523`*^9}, {
  3.5867453198549404`*^9, 3.5867453295053816`*^9}}],

Cell[BoxData[{
 RowBox[{"<<", "LiteRed`"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "Mint`"}]}], "Input",
 CellChangeTimes->{{3.5856212743040657`*^9, 3.5856212816660213`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Declare", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"k1", ",", "k2", ",", "k3", ",", "k4", ",", "p"}], "}"}], ",", 
    "Vector"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sp", "[", 
    RowBox[{"p", ",", "p"}], "]"}], "=", "1"}], ";"}]}], "Input",
 CellChangeTimes->{{3.58555437616904*^9, 3.585554398777092*^9}, 
   3.58555462568817*^9, {3.5856169150168824`*^9, 3.5856169159104767`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NewBasis", "[", 
   RowBox[{"gnp", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       RowBox[{"sp", "[", 
        RowBox[{"k1", ",", "k2"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       RowBox[{"sp", "[", 
        RowBox[{"k3", ",", "k4"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       RowBox[{"sp", "[", 
        RowBox[{"k2", ",", "k3"}], "]"}]}], ",", 
      RowBox[{"-", 
       RowBox[{"sp", "[", "k1", "]"}]}], ",", 
      RowBox[{"-", 
       RowBox[{"sp", "[", "k2", "]"}]}], ",", 
      RowBox[{"-", 
       RowBox[{"sp", "[", "k3", "]"}]}], ",", 
      RowBox[{"-", 
       RowBox[{"sp", "[", "k4", "]"}]}], ",", 
      RowBox[{"1", "-", 
       RowBox[{"sp", "[", 
        RowBox[{"k1", "+", "p"}], "]"}]}], ",", 
      RowBox[{"1", "-", 
       RowBox[{"sp", "[", 
        RowBox[{"k1", "+", "k2", "+", "p"}], "]"}]}], ",", 
      RowBox[{"1", "-", 
       RowBox[{"sp", "[", 
        RowBox[{"k1", "+", "k2", "+", "k3", "+", "p"}], "]"}]}], ",", 
      RowBox[{"1", "-", 
       RowBox[{"sp", "[", 
        RowBox[{"k1", "+", "k2", "+", "k3", "+", "k4", "+", "p"}], "]"}]}], 
      ",", 
      RowBox[{"1", "-", 
       RowBox[{"sp", "[", 
        RowBox[{"k2", "+", "k3", "+", "k4", "+", "p"}], "]"}]}], ",", 
      RowBox[{"1", "-", 
       RowBox[{"sp", "[", 
        RowBox[{"k3", "+", "k4", "+", "p"}], "]"}]}], ",", 
      RowBox[{"1", "-", 
       RowBox[{"sp", "[", 
        RowBox[{"k4", "+", "p"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k1", ",", "k2", ",", "k3", ",", "k4"}], "}"}]}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{
  3.585621308069645*^9, 3.5856213905938416`*^9, {3.5856214648593855`*^9, 
   3.5856214870511627`*^9}, 3.585621546332632*^9}],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"CountMIs", "[", 
   RowBox[{"js", "[", 
    RowBox[{
    "gnp", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
     "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
     "1"}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.585621495265631*^9, 3.5856215343986855`*^9}, {
  3.5856215811798315`*^9, 3.585621585390635*^9}, {3.585639742704689*^9, 
  3.5856397547016764`*^9}, {3.586671195229554*^9, 3.586671195373651*^9}, {
  3.5867454277540197`*^9, 3.5867454300835752`*^9}, {3.58674605417522*^9, 
  3.586746068298645*^9}}],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"FindMIs", "[", 
   RowBox[{"js", "[", 
    RowBox[{
    "gnp", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
     "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
     "1"}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5867454335628977`*^9, 3.586745435467169*^9}}],

Cell["\<\
In order to use Method\[Rule]\[CloseCurlyDoubleQuote]GramP\
\[CloseCurlyDoubleQuote], first run FindSymmetries\
\>", "Text",
 CellChangeTimes->{{3.586746116585926*^9, 3.5867461687867703`*^9}}],

Cell[BoxData[{
 RowBox[{"GenerateIBP", "[", "gnp", "]"}], "\[IndentingNewLine]", 
 RowBox[{"AnalyzeSectors", "[", 
  RowBox[{"gnp", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "__"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"FindSymmetries", "[", "gnp", "]"}]}], "Input",
 CellChangeTimes->{{3.5867453453419533`*^9, 3.5867453931098957`*^9}}],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"CountMIs", "[", 
   RowBox[{
    RowBox[{"js", "[", 
     RowBox[{
     "gnp", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
      "1"}], "]"}], ",", 
    RowBox[{"Method", "\[Rule]", "\"\<GramP\>\""}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.585621495265631*^9, 3.5856215343986855`*^9}, {
  3.5856215811798315`*^9, 3.585621585390635*^9}, {3.585639742704689*^9, 
  3.5856397547016764`*^9}, {3.586671195229554*^9, 3.586671195373651*^9}, {
  3.5867454065588717`*^9, 3.5867454429541664`*^9}, {3.586746040992421*^9, 
  3.586746045285286*^9}, {3.586746126784734*^9, 3.586746126926828*^9}}],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"FindMIs", "[", 
   RowBox[{
    RowBox[{"js", "[", 
     RowBox[{
     "gnp", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
      "1"}], "]"}], ",", 
    RowBox[{"Method", "\[Rule]", "\"\<GramP\>\""}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5867454223814335`*^9, 3.586745446786725*^9}}]
}, Open  ]]
},
WindowSize->{1000, 800},
WindowMargins->{{286, Automatic}, {53, Automatic}},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 182, 4, 90, "Title"],
Cell[764, 28, 174, 3, 52, "Input"],
Cell[941, 33, 462, 12, 52, "Input"],
Cell[1406, 47, 1825, 53, 72, "Input"],
Cell[3234, 102, 615, 12, 31, "Input"],
Cell[3852, 116, 365, 8, 31, "Input"],
Cell[4220, 126, 202, 4, 30, "Text"],
Cell[4425, 132, 374, 8, 72, "Input"],
Cell[4802, 142, 739, 14, 31, "Input"],
Cell[5544, 158, 442, 10, 31, "Input"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
